#define MODULE
#define __KERNEL__
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/config.h>
#include <linux/stddef.h>
#include <linux/module.h> 
#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/sched.h>
#include <linux/dirent.h>
#include <linux/fs.h>
#include <linux/malloc.h>
#include <linux/unistd.h> 
#include <linux/string.h>
#include <sys/syscall.h>
#include <linux/dcache.h>
#include <linux/dirent.h>
#include <linux/file.h>
#include <asm/uaccess.h>
#include <linux/smp_lock.h>
#include <linux/capability.h>  

struct task_struct *init_hook = NULL;
extern void *sys_call_table[];

int (*o_ptrace)(int, int, int, int);

int n_ptrace(int req, int pid, int addr, int data)
{
	if (current->uid != 0)
		return(EPERM);

	return(o_ptrace(req, pid, addr, data));
}

#define REPLACE(x) o_##x = sys_call_table[__NR_##x];\
			sys_call_table[__NR_##x] = n_##x
int init_module(void)
{
	struct task_struct *p = current;
	lock_kernel();
	EXPORT_NO_SYMBOLS;
	for(;p->pid != 1; p = p->next_task) ;
	init_hook = p;
	REPLACE(ptrace);
	unlock_kernel();
	return(0);
}

#define RESTORE(x) sys_call_table[__NR_##x] = o_##x
int cleanup_module(void)
{
	lock_kernel();
	RESTORE(ptrace);
	unlock_kernel();
	return(0);
}

